import * as action from '../../actions'

import { useState } from 'react';
import { connect } from 'react-redux';
import { Link } from 'react-router-dom';
import { history } from '../../App';

const PlaylistAdd = ({addPlaylist}) => {
  let [clicked, setClicked] = useState(false)
  let [name, setName] = useState()
  return (
    <div>
      {
        !clicked?
          <button 
            style={{ border: '1px solid black', backgroundColor: 'mediumseagreen',width : '95%',padding: '5px', margin: '5px' }}
            onClick={() => setClicked(true)}
          >NEW PLAYLIST</button>
          :
          <div style={{width : '95%', margin:'0 auto'}}>
            <input 
              style={{width:'72%', padding:'5px'}} 
              placeholder='Playlist name'
              value={name}
              onChange={(e) => setName(e.target.value)}
            />

            <button
              disabled={!name}
              style={{padding:'5px', backgroundColor:'mediumseagreen'}}
              onClick={() => {addPlaylist(name); setClicked(false); setName('');}}
            >+</button>

            <button
              style={{padding:'5px', backgroundColor:'red'}} 
              onClick={() => {setClicked(false); setName('')}}
            >X</button>
          </div>
      }
    </div>
  )
}
const PlaylistAddConnect = connect(null, {addPlaylist: action.actionAddPlaylist})(PlaylistAdd)

const Playlists = ({playlists}) => {
  return (
    <div style={{backgroundColor: 'lightcyan'}}>
      <PlaylistAddConnect />
      {
        playlists?.payload? playlists.payload.map(item => {
          return (
            <Link 
              style={{display:'block', backgroundColor: 'darkcyan', color: 'cyan', margin: '5px', padding:'5px'}} 
              to={`${history.location.pathname}/playlist/:${item._id}`}
            >{item.name}</Link>
          )
        }) : '' 
      }
    </div>
  )
}
export const PlaylistsConnect = connect(state => ({playlists: state.promise.userPlaylists || {}}))(Playlists)
